# HG changeset patch
# User Barbara Locsi <locsi.barbara@gmail.com>
# Date 1468241214 -7200
#      Mon Jul 11 14:46:54 2016 +0200
# Node ID 60a971769d83ec535541a079628cad4ef605f12c
# Parent  1e6628b3dc0ea6a75f1e245ebdeaa56f2082306b
eig.cc: add vector/matrix flag to eig

diff -r 1e6628b3dc0e -r 60a971769d83 libinterp/corefcn/eig.cc
--- a/libinterp/corefcn/eig.cc	Fri Jul 01 23:04:43 2016 +0200
+++ b/libinterp/corefcn/eig.cc	Mon Jul 11 14:46:54 2016 +0200
@@ -52,7 +52,7 @@ The eigenvalues returned by @code{eig} a
 {
   int nargin = args.length ();
 
-  if (nargin > 3 || nargin == 0)
+  if (nargin > 4 || nargin == 0)
     print_usage ();
 
   octave_value_list retval;
@@ -80,6 +80,10 @@ The eigenvalues returned by @code{eig} a
   
   bool balance = true;
   bool force_qz = false;
+  bool v_flag = false;
+  bool m_flag = false;
+  bool b_flag = false;
+  bool nb_flag = false;
   
   // determine if it's AEP or GEP
   bool AEPcase = nargin == 1 || args(1).is_string ();
@@ -89,17 +93,38 @@ The eigenvalues returned by @code{eig} a
       if (nargin == 2)
         {
           std::string a1s = args(1).string_value ();
-          if(a1s != "balance" && a1s != "nobalance")
+          if (a1s != "balance" && a1s != "nobalance" && a1s!="vector" && a1s!="matrix")
             error ("eig: unexpected second input: %s", a1s.c_str ());
-          balance = a1s == "balance";
+          b_flag = a1s == "balance";
+          nb_flag = a1s == "nobalance";
+          v_flag = a1s == "vector";
+          m_flag = a1s == "matrix";
         }
       if (nargin == 3)
         {
-          if(!args(2).is_string ())
+          std::string a1s = args(1).string_value ();
+          if (a1s != "balance" && a1s != "nobalance" && a1s!="vector" && a1s!="matrix")
+            error ("eig: unexpected second input: %s", a1s.c_str ());
+          if (!args(2).is_string ())
+            err_wrong_type_arg ("eig", args(2));
+          
+          std::string a2s = args(2).string_value ();
+          if (a2s != "balance" && a2s != "nobalance" && a2s!="vector" && a2s!="matrix")
+            error ("eig: unexpected third input: %s", a2s.c_str ());
+          b_flag = a1s == "balance" || a2s == "balance";
+          nb_flag = a1s == "nobalance" || a2s == "nobalance";
+          v_flag = a1s == "vector" || a2s == "vector";
+          m_flag = a1s == "matrix" || a2s == "matrix";
+        }
+      if (nargin == 4)
+        {
+          if (!args(2).is_string ())
             err_wrong_type_arg ("eig", args(2));
           std::string a2s = args(2).string_value ();
-            error ("eig: unexpected third input: %s", a2s.c_str ());
+          if (a2s != "balance" && a2s != "nobalance" && a2s!="vector" && a2s!="matrix")
+            error ("eig: unexpected fourth input: %s", a2s.c_str ());
         }
+
     }
   else
     {
@@ -115,16 +140,44 @@ The eigenvalues returned by @code{eig} a
 
       if (! arg_b.is_single_type () && ! arg_b.is_double_type ())
         err_wrong_type_arg ("eig", arg_b);
-      if(nargin == 3)
+      if (nargin == 3)
         {
-          if(!args(2).is_string ())
+          if (!args(2).is_string ())
             err_wrong_type_arg ("eig", args(2));
           std::string a2s = args(2).string_value ();
-          if(a2s != "chol" && a2s != "qz")
+          if (a2s != "chol" && a2s != "qz" && a2s!="vector" && a2s!="matrix")
             error ("eig: unexpected third input: %s", a2s.c_str ());
           force_qz = a2s == "qz";
+          v_flag = a2s == "vector";
+          m_flag = a2s == "matrix";
+        }
+      if (nargin == 4)
+        {
+          if (!args(2).is_string ())
+            err_wrong_type_arg ("eig", args(2));
+          std::string a2s = args(2).string_value ();
+          if (a2s != "chol" && a2s != "qz" && a2s!="vector" && a2s!="matrix")
+            error ("eig: unexpected third input: %s", a2s.c_str ());
+          
+          if (!args(3).is_string ())
+            err_wrong_type_arg ("eig", args(3));
+          std::string a3s = args(3).string_value ();
+          if (a3s != "chol" && a3s != "qz" && a3s!="vector" && a3s!="matrix")
+            error ("eig: unexpected third input: %s", a3s.c_str ());
+          
+          force_qz = a2s == "qz" || a3s == "qz";
+          v_flag = a2s == "vector" || a3s == "vector";
+          m_flag = a2s == "matrix" || a3s == "matrix";
         }
     }
+  
+  if (b_flag && nb_flag)
+    error ("eig: the combination of flags is invalid.");
+  if (v_flag && m_flag)
+    error ("eig: the combination of flags is invalid.");
+  if(nb_flag)
+    balance = false;
+  
     
   if (!AEPcase && nr_b != nc_b)
     err_square_matrix_required ("eig", "B");
@@ -172,20 +225,39 @@ The eigenvalues returned by @code{eig} a
 
       if (nargout == 0 || nargout == 1)
         {
-          retval = ovl (result.eigenvalues ());
+          if (m_flag)
+            {
+              FloatComplexDiagMatrix d (result.eigenvalues ());
+              retval = ovl (d);
+            }
+          else
+            {
+              retval = ovl (result.eigenvalues ());
+            }
         }
       else if (nargout == 2)
         {
-          // Blame it on Matlab.
-          FloatComplexDiagMatrix d (result.eigenvalues ());
-
-          retval = ovl (result.right_eigenvectors (), d);
+          if (v_flag)
+            {
+              retval = ovl (result.right_eigenvectors (), result.eigenvalues ());
+            }
+          else
+            {
+              FloatComplexDiagMatrix d (result.eigenvalues ());
+              retval = ovl (result.right_eigenvectors (), d);
+            }
         }
       else
         {
-          FloatComplexDiagMatrix d (result.eigenvalues ());
-
-          retval = ovl (result.right_eigenvectors (), d, result.left_eigenvectors ());
+          if (v_flag)
+            {
+             retval = ovl (result.right_eigenvectors (), result.eigenvalues (), result.left_eigenvectors ());
+            }
+          else
+            {
+               FloatComplexDiagMatrix d (result.eigenvalues ());
+               retval = ovl (result.right_eigenvectors (), d, result.left_eigenvectors ());
+            }
         }
     }
   else
@@ -227,21 +299,40 @@ The eigenvalues returned by @code{eig} a
 
       if (nargout == 0 || nargout == 1)
         {
-          retval = ovl (result.eigenvalues ());
+          if (m_flag)
+            {
+              ComplexDiagMatrix d (result.eigenvalues ());
+              retval = ovl (d);
+            }
+          else
+            {
+              retval = ovl (result.eigenvalues ());
+            }    
         }
       else if(nargout == 2)
         {
-          // Blame it on Matlab.
-          ComplexDiagMatrix d (result.eigenvalues ());
-
-          retval = ovl (result.right_eigenvectors (), d);
+          if (v_flag)
+            {
+              retval = ovl (result.right_eigenvectors (), result.eigenvalues ());
+            }
+          else
+            {
+              ComplexDiagMatrix d (result.eigenvalues ());
+              retval = ovl (result.right_eigenvectors (), d);
+            }
         }
       else
         {
-          ComplexDiagMatrix d (result.eigenvalues ());
-
-          retval = ovl (result.right_eigenvectors (), d, result.left_eigenvectors ());
-        
+          
+          if (v_flag)
+            {
+             retval = ovl (result.right_eigenvectors (), result.eigenvalues (), result.left_eigenvectors ());
+            }
+          else
+            {
+               ComplexDiagMatrix d (result.eigenvalues ());
+               retval = ovl (result.right_eigenvectors (), d, result.left_eigenvectors ());
+            }
         }
     }
 
@@ -572,6 +663,439 @@ The eigenvalues returned by @code{eig} a
 %! assert (D1, D3);
 %! assert (isequal (V1, V2), false);
 
+%!test
+%! A = [1, 2; 2, 1];
+%! d = eig (A);
+%! assert (columns(d), 1);
+%! d2 = eig (A, 'vector');
+%! assert (columns(d2), 1);
+%! [v, d3] = eig (A);
+%! assert (isdiag(d3), true);
+%! d4 = eig (A, 'matrix');
+%! assert (isdiag(d4), true);
+%! assert (d, d2);
+%! assert (d3, d4);
+%! assert (d, diag(d3));
+
+%!test
+%! A = [1, 2; 2, 1];
+%! [v, d, w] = eig (A, 'balance', 'vector');
+%! assert (columns(d), 1);
+%! [v2, d2, w2] = eig (A, 'vector', 'balance');
+%! assert (columns(d2), 1);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 2; 2, 1];
+%! [v, d, w] = eig (A, 'balance', 'matrix');
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, 'matrix', 'balance');
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 2; 2, 1];
+%! [v, d, w] = eig (A, 'nobalance', 'matrix');
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, 'matrix', 'nobalance');
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 2; 2, 1];
+%! [v, d, w] = eig (A, 'nobalance', 'vector');
+%! assert (columns(d), 1);
+%! [v2, d2, w2] = eig (A, 'vector', 'nobalance');
+%! assert (columns(d2), 1);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1, 2; 2, 1]);
+%! d = eig (A);
+%! assert (columns(d), 1);
+%! d2 = eig (A, 'vector');
+%! assert (columns(d2), 1);
+%! [v, d3] = eig (A);
+%! assert (isdiag(d3), true);
+%! d4 = eig (A, 'matrix');
+%! assert (isdiag(d4), true);
+%! assert (d, d2);
+%! assert (d3, d4);
+%! assert (d, diag(d3));
+
+%!test
+%! A = single ([1, 2; 2, 1]);
+%! [v, d, w] = eig (A, 'balance', 'vector');
+%! assert (columns(d), 1);
+%! [v2, d2, w2] = eig (A, 'vector', 'balance');
+%! assert (columns(d2), 1);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1, 2; 2, 1]);
+%! [v, d, w] = eig (A, 'balance', 'matrix');
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, 'matrix', 'balance');
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1, 2; 2, 1]);
+%! [v, d, w] = eig (A, 'nobalance', 'matrix');
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, 'matrix', 'nobalance');
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1, 2; 2, 1]);
+%! [v, d, w] = eig (A, 'nobalance', 'vector');
+%! assert (columns(d), 1);
+%! [v2, d2, w2] = eig (A, 'vector', 'nobalance');
+%! assert (columns(d2), 1);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 2; -1, 1];  B = [3, 3; 1, 2];
+%! d = eig (A, B);
+%! assert (columns(d), 1);
+%! d2 = eig (A, B, 'vector');
+%! assert (columns(d2), 1);
+%! [v, d3] = eig (A, B);
+%! assert (isdiag(d3), true);
+%! d4 = eig (A, B, 'matrix');
+%! assert (isdiag(d4), true);
+%! assert (d, d2);
+%! assert (d3, d4);
+%! assert (d, diag(d3));
+
+%!test
+%! A = [1, 2; -1, 1];  B = [3, 3; 1, 2];
+%! [v, d, w] = eig (A, B, 'qz', 'vector');
+%! assert (columns(d), 1);
+%! [v2, d2, w2] = eig (A, B, 'vector', 'qz');
+%! assert (columns(d2), 1);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 2; -1, 1];  B = [3, 3; 1, 2];
+%! [v, d, w] = eig (A, B, 'qz', 'matrix');
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, 'matrix', 'qz');
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 2; -1, 1];  B = [3, 3; 1, 2];
+%! [v, d, w] = eig (A, B, 'chol', 'matrix');
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, 'matrix', 'chol');
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 2; -1, 1];  B = [3, 3; 1, 2];
+%! [v, d, w] = eig (A, B, 'chol', 'vector');
+%! assert (columns(d), 1);
+%! [v2, d2, w2] = eig (A, B, 'vector', 'chol');
+%! assert (columns(d2), 1);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1, 2; -1, 1]);  B = single ([3, 3; 1, 2]);
+%! d = eig (A, B);
+%! assert (columns(d), 1);
+%! d2 = eig (A, B, 'vector');
+%! assert (columns(d2), 1);
+%! [v, d3] = eig (A, B);
+%! assert (isdiag(d3), true);
+%! d4 = eig (A, B, 'matrix');
+%! assert (isdiag(d4), true);
+%! assert (d, d2);
+%! assert (d3, d4);
+%! assert (d, diag(d3));
+
+%!test
+%! A = single ([1, 2; -1, 1]);  B = single ([3, 3; 1, 2]);
+%! [v, d, w] = eig (A, B, 'qz', 'vector');
+%! assert (columns(d), 1);
+%! [v2, d2, w2] = eig (A, B, 'vector', 'qz');
+%! assert (columns(d2), 1);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1, 2; -1, 1]);  B = single ([3, 3; 1, 2]);
+%! [v, d, w] = eig (A, B, 'qz', 'matrix');
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, 'matrix', 'qz');
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1, 2; -1, 1]);  B = single ([3, 3; 1, 2]);
+%! [v, d, w] = eig (A, B, 'chol', 'matrix');
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, 'matrix', 'chol');
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1, 2; -1, 1]);  B = single ([3, 3; 1, 2]);
+%! [v, d, w] = eig (A, B, 'chol', 'vector');
+%! assert (columns(d), 1);
+%! [v2, d2, w2] = eig (A, B, 'vector', 'chol');
+%! assert (columns(d2), 1);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1+3i, 2+i; 2-i, 1+3i];  B = [5+9i, 2+i; 2-i, 5+9i];
+%! d = eig (A, B);
+%! assert (columns(d), 1);
+%! d2 = eig (A, B, 'vector');
+%! assert (columns(d2), 1);
+%! [v, d3] = eig (A, B);
+%! assert (isdiag(d3), true);
+%! d4 = eig (A, B, 'matrix');
+%! assert (isdiag(d4), true);
+%! assert (d, d2);
+%! assert (d3, d4);
+%! assert (d, diag(d3));
+
+%!test
+%! A = [1+3i, 2+i; 2-i, 1+3i];  B = [5+9i, 2+i; 2-i, 5+9i];
+%! [v, d, w] = eig (A, B, 'qz', 'vector');
+%! assert (columns(d), 1);
+%! [v2, d2, w2] = eig (A, B, 'vector', 'qz');
+%! assert (columns(d2), 1);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1+3i, 2+i; 2-i, 1+3i];  B = [5+9i, 2+i; 2-i, 5+9i];
+%! [v, d, w] = eig (A, B, 'qz', 'matrix');
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, 'matrix', 'qz');
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1+3i, 2+i; 2-i, 1+3i];  B = [5+9i, 2+i; 2-i, 5+9i];
+%! [v, d, w] = eig (A, B, 'chol', 'matrix');
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, 'matrix', 'chol');
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1+3i, 2+i; 2-i, 1+3i];  B = [5+9i, 2+i; 2-i, 5+9i];
+%! [v, d, w] = eig (A, B, 'chol', 'vector');
+%! assert (columns(d), 1);
+%! [v2, d2, w2] = eig (A, B, 'vector', 'chol');
+%! assert (columns(d2), 1);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1+3i, 2+i; 2-i, 1+3i]);  B = single ([5+9i, 2+i; 2-i, 5+9i]);
+%! d = eig (A, B);
+%! assert (columns(d), 1);
+%! d2 = eig (A, B, 'vector');
+%! assert (columns(d2), 1);
+%! [v, d3] = eig (A, B);
+%! assert (isdiag(d3), true);
+%! d4 = eig (A, B, 'matrix');
+%! assert (isdiag(d4), true);
+%! assert (d, d2);
+%! assert (d3, d4);
+%! assert (d, diag(d3));
+
+%!test
+%! A = single ([1+3i, 2+i; 2-i, 1+3i]);  B = single ([5+9i, 2+i; 2-i, 5+9i]);
+%! [v, d, w] = eig (A, B, 'qz', 'vector');
+%! assert (columns(d), 1);
+%! [v2, d2, w2] = eig (A, B, 'vector', 'qz');
+%! assert (columns(d2), 1);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1+3i, 2+i; 2-i, 1+3i]);  B = single ([5+9i, 2+i; 2-i, 5+9i]);
+%! [v, d, w] = eig (A, B, 'qz', 'matrix');
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, 'matrix', 'qz');
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1+3i, 2+i; 2-i, 1+3i]);  B = single ([5+9i, 2+i; 2-i, 5+9i]);
+%! [v, d, w] = eig (A, B, 'chol', 'matrix');
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, 'matrix', 'chol');
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1+3i, 2+i; 2-i, 1+3i]);  B = single ([5+9i, 2+i; 2-i, 5+9i]);
+%! [v, d, w] = eig (A, B, 'chol', 'vector');
+%! assert (columns(d), 1);
+%! [v2, d2, w2] = eig (A, B, 'vector', 'chol');
+%! assert (columns(d2), 1);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 2; 3, 8];  B = [8, 3; 4, 3];
+%! d = eig (A, B);
+%! assert (columns(d), 1);
+%! d2 = eig (A, B, 'vector');
+%! assert (columns(d2), 1);
+%! [v, d3] = eig (A, B);
+%! assert (isdiag(d3), true);
+%! d4 = eig (A, B, 'matrix');
+%! assert (isdiag(d4), true);
+%! assert (d, d2);
+%! assert (d3, d4);
+%! assert (d, diag(d3));
+
+%!test
+%! A = [1, 2; 3, 8];  B = [8, 3; 4, 3];
+%! [v, d, w] = eig (A, B, 'qz', 'vector');
+%! assert (columns(d), 1);
+%! [v2, d2, w2] = eig (A, B, 'vector', 'qz');
+%! assert (columns(d2), 1);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+
+%!test
+%! A = [1, 2; 3, 8];  B = [8, 3; 4, 3];
+%! [v, d, w] = eig (A, B, 'qz', 'matrix');
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, 'matrix', 'qz');
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 2; 3, 8];  B = [8, 3; 4, 3];
+%! [v, d, w] = eig (A, B, 'chol', 'matrix');
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, 'matrix', 'chol');
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 2; 3, 8];  B = [8, 3; 4, 3];
+%! [v, d, w] = eig (A, B, 'chol', 'vector');
+%! assert (columns(d), 1);
+%! [v2, d2, w2] = eig (A, B, 'vector', 'chol');
+%! assert (columns(d2), 1);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 1+i; 1-i, 1];  B = [2, 0; 0, 2];
+%! d = eig (A, B);
+%! assert (columns(d), 1);
+%! d2 = eig (A, B, 'vector');
+%! assert (columns(d2), 1);
+%! [v, d3] = eig (A, B);
+%! assert (isdiag(d3), true);
+%! d4 = eig (A, B, 'matrix');
+%! assert (isdiag(d4), true);
+%! assert (d, d2);
+%! assert (d3, d4);
+%! assert (d, diag(d3));
+
+%!test
+%! A = [1, 1+i; 1-i, 1];  B = [2, 0; 0, 2];
+%! [v, d, w] = eig (A, B, 'qz', 'vector');
+%! assert (columns(d), 1);
+%! [v2, d2, w2] = eig (A, B, 'vector', 'qz');
+%! assert (columns(d2), 1);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 1+i; 1-i, 1];  B = [2, 0; 0, 2];
+%! [v, d, w] = eig (A, B, 'qz', 'matrix');
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, 'matrix', 'qz');
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 1+i; 1-i, 1];  B = [2, 0; 0, 2];
+%! [v, d, w] = eig (A, B, 'chol', 'matrix');
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, 'matrix', 'chol');
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 1+i; 1-i, 1];  B = [2, 0; 0, 2];
+%! [v, d, w] = eig (A, B, 'chol', 'vector');
+%! assert (columns(d), 1);
+%! [v2, d2, w2] = eig (A, B, 'vector', 'chol');
+%! assert (columns(d2), 1);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
 %!error eig ()
 %!error eig (false)
 %!error eig ([1, 2; 3, 4], [4, 3; 2, 1], 1)
@@ -584,6 +1108,12 @@ The eigenvalues returned by @code{eig} a
 %!error <wrong type argument> eig (false, [1 2 ; 2 3])
 %!error <eig: unexpected third input: abcd> eig ([1 2 ; 2 3], [1 2 ; 2 3], "abcd")
 %!error <eig: unexpected third input: qz> eig ([1 2 ; 2 3], 'balance', 'qz')
+%!error <eig: the combination of flags is invalid.> eig ([1 2 ; 2 3], 'balance', 'nobalance')
+%!error <eig: the combination of flags is invalid.> eig ([1 2 ; 2 3], 'nobalance', 'balance')
+%!error <eig: the combination of flags is invalid.> eig ([1 2 ; 2 3], 'matrix', 'vector')
+%!error <eig: the combination of flags is invalid.> eig ([1 2 ; 2 3], 'vector', 'matrix')
+%!error <eig: the combination of flags is invalid.> eig ([1 2 ; 2 3], [1 2 ; 2 3], 'matrix', 'vector')
+%!error <eig: the combination of flags is invalid.> eig ([1 2 ; 2 3], [1 2 ; 2 3], 'vector', 'matrix')
 %!error <wrong type argument> eig ([1 2 ; 2 3], [1 2 ; 2 3], false)
 %!error <wrong type argument> eig ([1 2 ; 2 3], [1 2 ; 2 3], [1 2 ; 2 3])

